<?php

namespace Service;

class Menu {
    
    protected $connection;
    protected $util;
    
    public function __construct($connection, \Odhen\API\Util\Util $util) {
        $this->connection = $connection;
        $this->util = $util;
    }

    public function getGroups($CDFILIAL, $CDCAIXA) {
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA' => $CDCAIXA
		);
		try {
			if($this->checkForConfTela()['error'] == false){
				$confTelaCaixa = $this->getConfTelaCaixa($CDFILIAL, $CDCAIXA);
				if(!empty($confTelaCaixa['data'])){
					$params['DTINIVIGENCIA'] = $confTelaCaixa['data'][0]['DTINIVIGENCIA'];
					$groups = $this->connection->fetchAll(\Util\Query::GET_GROUPS_CONFTELA, $params);
				} else {
					$groups = $this->connection->fetchAll(\Util\Query::GET_GROUPS, $params);
				}
			} else {
				$groups = $this->connection->fetchAll(\Util\Query::GET_GROUPS, $params);
			}
			if(empty($groups)) throw new \Exception("Não foram encontrados grupos de produtos para esta filial/caixa");
			$return = array(
				'error' => false,
				'data'  => $groups
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos de produtos. Erro: '.$e->getMessage()
			);
		}
		return $return;
	}

    public function getGroupsFromConftelaEx($CDFILIAL, $NRCONFTELA) {
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'NRCONFTELA' => $NRCONFTELA
        );

        try {
            $groups = $this->connection->fetchAll(\Util\Query::GET_GROUPS_FROM_CONFTELA_EX, $params);
            
            if(empty($groups)) throw new \Exception("Não foram encontrados grupos de produtos para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $groups
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos de produtos. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getSubGroupsFromConftelaEx($CDFILIAL, $NRCONFTELA) {
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'NRCONFTELA' => $NRCONFTELA
        );

        try {
            $groups = $this->connection->fetchAll(\Util\Query::GET_SUB_GROUPS_FROM_CONFTELA_EX, $params);
            
            if(empty($groups)) throw new \Exception("Não foram encontrados sub grupos de produtos para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $groups
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos de produtos. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getProductsFromConftelaEx($CDFILIAL, $NRCONFTELA, $subsidiaryCode) {
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'NRCONFTELA' => $NRCONFTELA,
            'CDFILIPREC' => $subsidiaryCode
        );

        try {
            $products = $this->connection->fetchAll(\Util\Query::GET_PRODUCTS_FROM_CONFTELA_EX_WITH_PRICE, $params);
            
            if(empty($products)) throw new \Exception("Não foram encontrados produtos para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $products
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}
    /*
    public function getProductsFromConftelaEx($CDFILIAL, $NRCONFTELA) {
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'NRCONFTELA' => $NRCONFTELA
        );

        try {
            $products = $this->connection->fetchAll(\Util\Query::GET_PRODUCTS_FROM_CONFTELA_EX, $params);
            
            if(empty($products)) throw new \Exception("Não foram encontrados produtos para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $products
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}
    */
    public function getLocalGroupsPromoFromConftelaEx($comboCodes, $subsidiaryCode) {
        $params = array(
            'ARR' => $comboCodes,
            'CDFILIAL' => $subsidiaryCode
        );

        $types = [
            'ARR' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        ];

        try {
            $groupsPromo = $this->connection->fetchAll(\Util\Query::GET_LOCAL_GROUPS_PROMO_FROM_CONFTELA_EX, $params, $types);

            $return = array(
				'error' => false,
				'data'  => $groupsPromo
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos promocionais. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getLocalGroupsPromoFromConftelaExWithPrice($comboCodes, $subsidiaryCode) {
        $params = array(
            'ARR' => $comboCodes,
            'CDFILIAL' => $subsidiaryCode
        );

        $types = [
            'ARR' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        ];

        try {
            $groupsPromo = $this->connection->fetchAll(\Util\Query::GET_LOCAL_GROUPS_PROMO_FROM_CONFTELA_EX_WITH_PRICE, $params, $types);

            $return = array(
				'error' => false,
				'data'  => $groupsPromo
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos promocionais. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getAddProducts() {
      try {
        $products = $this->connection->fetchAll(\Util\Query::GET_ADDITIONAL_PRODUCTS_EX);

        $return = array(
          'error' => false,
          'data'  => $products
        );
      } catch (\Exception $e) {
        $return = array(
          'error' => true,
          'message' => 'Erro ao buscar produtos adicionais. Erro: '.$e->getMessage()
        );
      }
    
      return $return;
    }

    public function getGroupsPromoFromConftelaEx($comboCodes) {
        $params = array(
            $comboCodes
        );

        $types = [\Doctrine\DBAL\Connection::PARAM_STR_ARRAY];

        try {
            $groupsPromo = $this->connection->fetchAll(\Util\Query::GET_GROUPS_PROMO_FROM_CONFTELA_EX, $params, $types);
            
            if(empty($groupsPromo)) throw new \Exception("Não foram encontrados grupos promocionais para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $groupsPromo
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos promocionais. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getGroupsPromoFromConftelaExWithPrice($comboCodes, $subsidiaryCode) {
        $params = array(
            'ARR' => $comboCodes,
            'CDFILIAL' => $subsidiaryCode
        );
        
        $types = [
            'ARR' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        ];

        try {
            $groupsPromo = $this->connection->fetchAll(\Util\Query::GET_GROUPS_PROMO_FROM_CONFTELA_EX_WITH_PRICE, $params, $types);
            
            if(empty($groupsPromo)) throw new \Exception("Não foram encontrados grupos promocionais para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $groupsPromo
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar grupos promocionais. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getObservationsFromConftelaEx($CDFILIAL, $CDLOJA) {
        $params = array(
            [$CDFILIAL],
            [$CDLOJA]
        );

        $types = [
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY,
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        ];

        try {
            $observations = $this->connection->fetchAll(\Util\Query::GET_OBSERVATIONS_FROM_CONFTELA_EX, $params, $types);
            
            if(empty($observations)) throw new \Exception("Não foram encontradas observacoes para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $observations
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar observacoes. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getGroupPromoProductsFromConftelaEx($comboGroupCodes, $NRCONFTELA) {
        $params = array(
            [$NRCONFTELA],
            $comboGroupCodes
        );

        $types = [
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY,
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        ];

        try {
            $groupsPromoPoducts = $this->connection->fetchAll(\Util\Query::GET_GROUP_PROMO_PRODS_FROM_CONFTELA_EX, $params, $types);
            
            if(empty($groupsPromoPoducts)) throw new \Exception("Não foram encontrados produtos de grupos promocionais para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $groupsPromoPoducts
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos de grupos promocionais. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getGroupPromoProductsFromConftelaExWithPrice($comboGroupCodes, $NRCONFTELA, $cdfilial) {
        $params = array(
            [$NRCONFTELA],
            [$cdfilial],
            $comboGroupCodes
        );

        $types = [
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY,
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY,
            \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        ];

        try {
            $groupsPromoPoducts = $this->connection->fetchAll(\Util\Query::GET_GROUP_PROMO_PRODS_FROM_CONFTELA_EX_WITH_PRICE, $params, $types);
            
            if(empty($groupsPromoPoducts)) throw new \Exception("Não foram encontrados produtos de grupos promocionais para esta filial/conftela");

            $return = array(
				'error' => false,
				'data'  => $groupsPromoPoducts
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos de grupos promocionais. Erro: '.$e->getMessage()
			);
		}
        
		return $return;
	}

    public function getTabPrec($CDFILIAL, $CDLOJA){
        $params = array(
            ":CDFILIAL" => $CDFILIAL,
            ":CDLOJA" => $CDLOJA
        );

        try{
            $isBranchTable = true;
            $tabePrec = $this->connection->fetchAll(\Util\Query::GET_BRANCH_TABEPREC, $params);

            if(empty($tabePrec)){
                $isBranchTable = false;
                $tabePrec = $this->connection->fetchAll(\Util\Query::GET_GENERAL_TABEPREC);
            }

            if(empty($tabePrec)){
                throw new \Exception("Não foi encontrada tabela de precos parametrizadas");
            } else{
                $tabePrec = $tabePrec[0];
            }

            $return = array(
				'error' => false,
				'data'  => $tabePrec,
                'isBranchTable' => $isBranchTable
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar tabela de precos. Erro: '.$e->getMessage()
			);
		}
    }

    public function getProductDailyPrices($tabePrec, $CDFILIAL){
        try{
            if($tabePrec['isBranchTable']){
                $params = array(
                    ":CDFILIAL" => $CDFILIAL,
                    ":CDTABEPREC" => $tabePrec['data']
                );

                $productDailyPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_TABEPRECDIA_PRICES, $params);
            } else{
                $params = array(
                    ":CDTABEPREC" => $tabePrec['data']
                );

                $productDailyPrices = $this->connection->fetchAll(\Util\Query::GET_GENERAL_TABEPRECDIA_PRICES, $params);
            }

            $return = array(
				'error' => false,
				'data'  => $productDailyPrices
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar precos diarios para a tabela de precos. Erro: '.$e->getMessage()
			);
		}
    }

    public function getProductDiffPrices($tabePrec, $CDFILIAL){
        try{
            if($tabePrec['isBranchTable']){
                $params = array(
                    ":CDFILIAL" => $CDFILIAL
                );

                $productDiffPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_DIFF_PRICES, $params);
            } else{
                $productDiffPrices = $this->connection->fetchAll(\Util\Query::GET_GENERAL_DIFF_PRICES);
            }

            $return = array(
				'error' => false,
				'data'  => $productDiffPrices
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos da tabela de precos. Erro: '.$e->getMessage()
			);
		}
    }

    public function isHoliday($CDFILIAL, $currentDay) {
        $check = $this->holidayCheck($CDFILIAL, $currentDay);
        
        if (!empty($check)) 
            return true;
        
        return false;
    }

    public function holidayCheck($CDFILIAL, $DTFERIFILI) {
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':DTFERIFILI' => $DTFERIFILI
        );

        return $this->connection->fetchAssoc(\Util\Query::HOLIDAY_CHECK, $params);
    }

    public function getProductPrices($CDFILIAL, $CDLOJA, $CDCLIENTE, $CDTIPOCONSPD) {
        try {

            //PEGAR DIA DA SEMANA
            $currentDay = date('d/m/Y');
            $nextDay = date('d/m/Y', strtotime('+1 day'));
            $NRDIASEMANPR = (string)((int)date('w') + 1);

            if ($this->isHoliday($CDFILIAL, $currentDay)) {
                $NRDIASEMANPR = 'F';
            } else if ($this->isHoliday($CDFILIAL, $nextDay)) {
                $NRDIASEMANPR = 'V';
            }

            $date = date('Y-m-d H:i:s');

            if(!empty($CDCLIENTE)) {
                // TABELA CLIENTE POR FILIAL
                $params = array(
                    ":CDFILIAL" => $CDFILIAL,
                    ":CDCLIENTE" => $CDCLIENTE
                );

                $cliBranchTabePrec = $this->connection->fetchAssoc(\Util\Query::GET_CLIENT_BRANCH_TABEPREC, $params);

                if(!empty($cliBranchTabePrec['CDTABEPREC'])){
                    $params = array(
                        ":CDFILIAL" => $CDFILIAL,
                        ":CDTABEPREC" => $cliBranchTabePrec['CDTABEPREC'],
                        ":DATA" => $date
                    );

                    $cliBranchTabePrecVig = $this->connection->fetchAssoc(\Util\Query::GET_TABEPREC_VIG, $params);

                    if(!empty($cliBranchTabePrecVig['DTINIVGPREC'])){
                        $params = array(
                            ":CDFILIAL" => $CDFILIAL,
                            ":CDTABEPREC" => $cliBranchTabePrec['CDTABEPREC']
                        );
                        $cliBranchTablePrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_TABEPREC_PRICES, $params);

                        $params = array(
                            ":CDFILIAL" => $CDFILIAL,
                            ":CDTABEPREC" => $cliBranchTabePrec['CDTABEPREC'],
                            ":CDTIPOCONSPD" => $CDTIPOCONSPD,
                            ":NRDIASEMANPR" => $NRDIASEMANPR
                        );
                        $cliBranchDailyPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_DAILY_PRICES, $params);
                    } else{
                        $cliBranchTablePrices = [];
                        $cliBranchDailyPrices = [];
                    }
                }  else{
                    $cliBranchTablePrices = [];
                    $cliBranchDailyPrices = [];
                }


                // TABELA CLIENTE
                $params = array(
                    ":CDCLIENTE" => $CDCLIENTE
                );

                $clientTabePrec = $this->connection->fetchAssoc(\Util\Query::GET_CLIENT_TABEPREC, $params);

                if(!empty($clientTabePrec['CDTABEPREC'])){
                    $params = array(
                        ":CDFILIAL" => $CDFILIAL,
                        ":CDTABEPREC" => $clientTabePrec['CDTABEPREC'],
                        ":DATA" => $date
                    );

                    $clientTabePrecVig = $this->connection->fetchAssoc(\Util\Query::GET_TABEPREC_VIG, $params);

                    if(!empty($clientTabePrecVig['DTINIVGPREC'])){
                        $params = array(
                            ":CDFILIAL" => $CDFILIAL,
                            ":CDTABEPREC" => $clientTabePrec['CDTABEPREC']
                        );
                        $clientTablePrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_TABEPREC_PRICES, $params);

                        $params = array(
                            ":CDFILIAL" => $CDFILIAL,
                            ":CDTABEPREC" => $clientTabePrec['CDTABEPREC'],
                            ":CDTIPOCONSPD" => $CDTIPOCONSPD,
                            ":NRDIASEMANPR" => $NRDIASEMANPR
                        );
                        $clientDailyPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_DAILY_PRICES, $params);
                    } else{
                        $clientTablePrices = [];
                        $clientDailyPrices = [];
                    }
                }  else{
                    $clientTablePrices = [];
                    $clientDailyPrices = [];
                }
            } else{
                $cliBranchTablePrices = [];
                $clientTablePrices = [];
                $cliBranchDailyPrices = [];
                $clientDailyPrices = [];
            }


            // TABELA POR LOJA
            $params = array(
                ":CDFILIAL" => $CDFILIAL,
                ":CDLOJA" => $CDLOJA
            );

            $storeTabePrec = $this->connection->fetchAssoc(\Util\Query::GET_STORE_TABEPREC, $params);

            if(!empty($storeTabePrec['CDTABEPREC'])){
                $params = array(
                    ":CDFILIAL" => $CDFILIAL,
                    ":CDTABEPREC" => $storeTabePrec['CDTABEPREC'],
                    ":DATA" => $date
                );

                $storeTabePrecVig = $this->connection->fetchAssoc(\Util\Query::GET_TABEPREC_VIG, $params);

                if(!empty($storeTabePrecVig['DTINIVGPREC'])){
                    $params = array(
                        ":CDFILIAL" => $CDFILIAL,
                        ":CDTABEPREC" => $storeTabePrec['CDTABEPREC']
                    );
                    $storeTablePrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_TABEPREC_PRICES, $params);

                    $params = array(
                        ":CDFILIAL" => $CDFILIAL,
                        ":CDTABEPREC" => $storeTabePrec['CDTABEPREC'],
                        ":CDTIPOCONSPD" => $CDTIPOCONSPD,
                        ":NRDIASEMANPR" => $NRDIASEMANPR
                    );
                    $storeDailyPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_DAILY_PRICES, $params);

                } else{
                    $storeTablePrices = [];
                    $storeDailyPrices = [];
                }
            }  else{
                $storeTablePrices = [];
                $storeDailyPrices = [];
            }


            // TABELA POR FILIAL
            $params = array(
                ":CDFILIAL" => $CDFILIAL
            );

            $branchTabePrec = $this->connection->fetchAssoc(\Util\Query::GET_BRANCH_TABEPREC, $params);

            if(!empty($branchTabePrec['CDTABEPREC'])){
                $params = array(
                    ":CDFILIAL" => $CDFILIAL,
                    ":CDTABEPREC" => $branchTabePrec['CDTABEPREC'],
                    ":DATA" => $date
                );

                $branchTabePrecVig = $this->connection->fetchAssoc(\Util\Query::GET_TABEPREC_VIG, $params);

                if(!empty($branchTabePrecVig['DTINIVGPREC'])){
                    $params = array(
                        ":CDFILIAL" => $CDFILIAL,
                        ":CDTABEPREC" => $branchTabePrec['CDTABEPREC']
                    );
                    $branchTablePrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_TABEPREC_PRICES, $params);

                    $params = array(
                        ":CDFILIAL" => $CDFILIAL,
                        ":CDTABEPREC" => $branchTabePrec['CDTABEPREC'],
                        ":CDTIPOCONSPD" => $CDTIPOCONSPD,
                        ":NRDIASEMANPR" => $NRDIASEMANPR
                    );
                    $branchDailyPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_DAILY_PRICES, $params);
                } else{
                    $branchTablePrices = [];
                    $branchDailyPrices = [];
                }
            }  else{
                $branchTablePrices = [];
                $branchDailyPrices = [];
            }


            // TABELA POR GERAL
            $params = array(
                ":CDFILIAL" => $CDFILIAL,
                ":DATA" => $date
            );

            $generalTabePrec = $this->connection->fetchAssoc(\Util\Query::GET_GENERAL_TABEPREC, $params);

            if(!empty($generalTabePrec['CDTABEPREC'])){
                $params = array(
                    ":CDTABEPREC" => $generalTabePrec['CDTABEPREC']
                );
                $generalTablePrices = $this->connection->fetchAll(\Util\Query::GET_GENERAL_TABEPREC_PRICES, $params);

                $params = array(
                    ":CDTABEPREC" => $generalTabePrec['CDTABEPREC'],
                    ":CDTIPOCONSPD" => $CDTIPOCONSPD,
                    ":NRDIASEMANPR" => $NRDIASEMANPR
                );
                $generalDailyPrices = $this->connection->fetchAll(\Util\Query::GET_GENERAL_DAILY_PRICES, $params);
            }  else{
                $generalTablePrices = [];
                $generalDailyPrices = [];
            }

            // CALCULO PRECO BASE FINAL
            $finalProductPrices = [];

            foreach($cliBranchTablePrices as $cliBranchProduct){
                $finalProductPrices[$cliBranchProduct['CDPRODUTO']] = $cliBranchProduct;
                $finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECO'] = (float)$this->formatPrice($finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECO']);
                $finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECOCLIE'] = (float)$this->formatPrice($finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECOCLIE']);
                $finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECOSUGER'] = (float)$this->formatPrice($finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECOSUGER']);
                $finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECODLV'] = (float)$this->formatPrice($finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECODLV']);
                $finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECOCMD'] = (float)$this->formatPrice($finalProductPrices[$cliBranchProduct['CDPRODUTO']]['PRECOCMD']);
                unset($finalProductPrices[$cliBranchProduct['CDPRODUTO']]['CDPRODUTO']);
            }

            foreach($clientTablePrices as $clientProduct){
                if(empty($finalProductPrices[$clientProduct['CDPRODUTO']])){
                    $finalProductPrices[$clientProduct['CDPRODUTO']] = $clientProduct;
                    $finalProductPrices[$clientProduct['CDPRODUTO']]['PRECO'] = (float)$this->formatPrice($finalProductPrices[$clientProduct['CDPRODUTO']]['PRECO']);
                    $finalProductPrices[$clientProduct['CDPRODUTO']]['PRECOCLIE'] = (float)$this->formatPrice($finalProductPrices[$clientProduct['CDPRODUTO']]['PRECOCLIE']);
                    $finalProductPrices[$clientProduct['CDPRODUTO']]['PRECOSUGER'] = (float)$this->formatPrice($finalProductPrices[$clientProduct['CDPRODUTO']]['PRECOSUGER']);
                    $finalProductPrices[$clientProduct['CDPRODUTO']]['PRECODLV'] = (float)$this->formatPrice($finalProductPrices[$clientProduct['CDPRODUTO']]['PRECODLV']);
                    $finalProductPrices[$clientProduct['CDPRODUTO']]['PRECOCMD'] = (float)$this->formatPrice($finalProductPrices[$clientProduct['CDPRODUTO']]['PRECOCMD']);
                    unset($finalProductPrices[$clientProduct['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            foreach($storeTablePrices as $storeProduct){
                if(empty($finalProductPrices[$storeProduct['CDPRODUTO']])){
                    $finalProductPrices[$storeProduct['CDPRODUTO']] = $storeProduct;
                    $finalProductPrices[$storeProduct['CDPRODUTO']]['PRECO'] = (float)$this->formatPrice($finalProductPrices[$storeProduct['CDPRODUTO']]['PRECO']);
                    $finalProductPrices[$storeProduct['CDPRODUTO']]['PRECOCLIE'] = (float)$this->formatPrice($finalProductPrices[$storeProduct['CDPRODUTO']]['PRECOCLIE']);
                    $finalProductPrices[$storeProduct['CDPRODUTO']]['PRECOSUGER'] = (float)$this->formatPrice($finalProductPrices[$storeProduct['CDPRODUTO']]['PRECOSUGER']);
                    $finalProductPrices[$storeProduct['CDPRODUTO']]['PRECODLV'] = (float)$this->formatPrice($finalProductPrices[$storeProduct['CDPRODUTO']]['PRECODLV']);
                    $finalProductPrices[$storeProduct['CDPRODUTO']]['PRECOCMD'] = (float)$this->formatPrice($finalProductPrices[$storeProduct['CDPRODUTO']]['PRECOCMD']);
                    unset($finalProductPrices[$storeProduct['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            foreach($branchTablePrices as $branchProduct){
                if(empty($finalProductPrices[$branchProduct['CDPRODUTO']])){
                    $finalProductPrices[$branchProduct['CDPRODUTO']] = $branchProduct;
                    $finalProductPrices[$branchProduct['CDPRODUTO']]['PRECO'] = (float)$this->formatPrice($finalProductPrices[$branchProduct['CDPRODUTO']]['PRECO']);
                    $finalProductPrices[$branchProduct['CDPRODUTO']]['PRECOCLIE'] = (float)$this->formatPrice($finalProductPrices[$branchProduct['CDPRODUTO']]['PRECOCLIE']);
                    $finalProductPrices[$branchProduct['CDPRODUTO']]['PRECOSUGER'] = (float)$this->formatPrice($finalProductPrices[$branchProduct['CDPRODUTO']]['PRECOSUGER']);
                    $finalProductPrices[$branchProduct['CDPRODUTO']]['PRECODLV'] = (float)$this->formatPrice($finalProductPrices[$branchProduct['CDPRODUTO']]['PRECODLV']);
                    $finalProductPrices[$branchProduct['CDPRODUTO']]['PRECOCMD'] = (float)$this->formatPrice($finalProductPrices[$branchProduct['CDPRODUTO']]['PRECOCMD']);
                    unset($finalProductPrices[$branchProduct['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            foreach($generalTablePrices as $generalProduct){
                if(empty($finalProductPrices[$generalProduct['CDPRODUTO']])){
                    $finalProductPrices[$generalProduct['CDPRODUTO']] = $generalProduct;
                    $finalProductPrices[$generalProduct['CDPRODUTO']]['PRECO'] = (float)$this->formatPrice($finalProductPrices[$generalProduct['CDPRODUTO']]['PRECO']);
                    $finalProductPrices[$generalProduct['CDPRODUTO']]['PRECOCLIE'] = (float)$this->formatPrice($finalProductPrices[$generalProduct['CDPRODUTO']]['PRECOCLIE']);
                    $finalProductPrices[$generalProduct['CDPRODUTO']]['PRECOSUGER'] = (float)$this->formatPrice($finalProductPrices[$generalProduct['CDPRODUTO']]['PRECOSUGER']);
                    $finalProductPrices[$generalProduct['CDPRODUTO']]['PRECODLV'] = (float)$this->formatPrice($finalProductPrices[$generalProduct['CDPRODUTO']]['PRECODLV']);
                    $finalProductPrices[$generalProduct['CDPRODUTO']]['PRECOCMD'] = (float)$this->formatPrice($finalProductPrices[$generalProduct['CDPRODUTO']]['PRECOCMD']);
                    unset($finalProductPrices[$generalProduct['CDPRODUTO']]['CDPRODUTO']);
                }
            }


            // CALCULO PRECO DIARIO FINAL
            $finalDailyPrices = [];

            foreach($cliBranchDailyPrices as $cliBranchDailyPrice){
                $finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']] = $cliBranchDailyPrice;
                $finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['VRPRECODIA'] = (float)$this->formatPrice($finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['VRPRECODIA']);
                $finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['VRPRECODIADLV'] = (float)$this->formatPrice($finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['VRPRECODIADLV']);
                $finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['VRPRECODIACMD'] = (float)$this->formatPrice($finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['VRPRECODIACMD']);
                unset($finalDailyPrices[$cliBranchDailyPrice['CDPRODUTO']]['CDPRODUTO']);
            }

            foreach($clientDailyPrices as $clientDailyPrice){
                if(empty($finalDailyPrices[$clientDailyPrice['CDPRODUTO']])){
                    $finalDailyPrices[$clientDailyPrice['CDPRODUTO']] = $clientDailyPrice;
                    $finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['VRPRECODIA'] = (float)$this->formatPrice($finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['VRPRECODIA']);
                    $finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['VRPRECODIADLV'] = (float)$this->formatPrice($finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['VRPRECODIADLV']);
                    $finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['VRPRECODIACMD'] = (float)$this->formatPrice($finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['VRPRECODIACMD']);
                    unset($finalDailyPrices[$clientDailyPrice['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            foreach($storeDailyPrices as $storeDailyPrice){
                if(empty($finalDailyPrices[$storeDailyPrice['CDPRODUTO']])){
                    $finalDailyPrices[$storeDailyPrice['CDPRODUTO']] = $storeDailyPrice;
                    $finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['VRPRECODIA'] = (float)$this->formatPrice($finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['VRPRECODIA']);
                    $finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['VRPRECODIADLV'] = (float)$this->formatPrice($finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['VRPRECODIADLV']);
                    $finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['VRPRECODIACMD'] = (float)$this->formatPrice($finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['VRPRECODIACMD']);
                    unset($finalDailyPrices[$storeDailyPrice['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            foreach($branchDailyPrices as $branchDailyPrice){
                if(empty($finalDailyPrices[$branchDailyPrice['CDPRODUTO']])){
                    $finalDailyPrices[$branchDailyPrice['CDPRODUTO']] = $branchDailyPrice;
                    $finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['VRPRECODIA'] = (float)$this->formatPrice($finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['VRPRECODIA']);
                    $finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['VRPRECODIADLV'] = (float)$this->formatPrice($finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['VRPRECODIADLV']);
                    $finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['VRPRECODIACMD'] = (float)$this->formatPrice($finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['VRPRECODIACMD']);
                    unset($finalDailyPrices[$branchDailyPrice['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            foreach($generalDailyPrices as $generalDailyPrice){
                if(empty($finalDailyPrices[$generalDailyPrice['CDPRODUTO']])){
                    $finalDailyPrices[$generalDailyPrice['CDPRODUTO']] = $generalDailyPrice;
                    $finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['VRPRECODIA'] = (float)$this->formatPrice($finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['VRPRECODIA']);
                    $finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['VRPRECODIADLV'] = (float)$this->formatPrice($finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['VRPRECODIADLV']);
                    $finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['VRPRECODIACMD'] = (float)$this->formatPrice($finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['VRPRECODIACMD']);
                    unset($finalDailyPrices[$generalDailyPrice['CDPRODUTO']]['CDPRODUTO']);
                }
            }

            $return = array(
				'error' => false,
				'prices' => $finalProductPrices,
                'dailyPrices' => $finalDailyPrices
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos da tabela de precos. Erro: '.$e->getMessage()
			);
		}

        return $return;
    }

    public function getComboPrices($CDFILIAL){
        try{
            $params = array(
                'CDFILIAL' => $CDFILIAL
            );
    
            $branchComboPrices = $this->connection->fetchAll(\Util\Query::GET_BRANCH_COMBO_PRICES, $params);
    
            $generalComboPrices = $this->connection->fetchAll(\Util\Query::GET_GENERAL_COMBO_PRICES, $params);
    
            $finalComboPrices = [];
    
            foreach($branchComboPrices as $branchComboPrice){
                $finalComboPrices[$branchComboPrice['CDPRODUTO']][$branchComboPrice['CDGRUPROMOC']][$branchComboPrice['CDPRODPROMOCAO']] = $branchComboPrice;
                $finalComboPrices[$branchComboPrice['CDPRODUTO']][$branchComboPrice['CDGRUPROMOC']][$branchComboPrice['CDPRODPROMOCAO']]['VRDESCONTO'] = (float)$this->formatPrice($finalComboPrices[$branchComboPrice['CDPRODUTO']][$branchComboPrice['CDGRUPROMOC']][$branchComboPrice['CDPRODPROMOCAO']]['VRDESCACR']);
                unset($finalComboPrices[$branchComboPrice['CDPRODUTO']][$branchComboPrice['CDGRUPROMOC']][$branchComboPrice['CDPRODPROMOCAO']]['CDPRODUTO']);
                unset($finalComboPrices[$branchComboPrice['CDPRODUTO']][$branchComboPrice['CDGRUPROMOC']][$branchComboPrice['CDPRODPROMOCAO']]['CDGRUPROMOC']);
                unset($finalComboPrices[$branchComboPrice['CDPRODUTO']][$branchComboPrice['CDGRUPROMOC']][$branchComboPrice['CDPRODPROMOCAO']]['CDPRODPROMOCAO']);
            }
    
            foreach($generalComboPrices as $generalComboPrice){
                if(empty($finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']])){
                    $finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']] = $generalComboPrice;
                    $finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']]['VRDESCONTO'] = (float)$this->formatPrice($finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']]['VRDESCACR']);
                    unset($finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']]['CDPRODUTO']);
                    unset($finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']]['CDGRUPROMOC']);
                    unset($finalComboPrices[$generalComboPrice['CDPRODUTO']][$generalComboPrice['CDGRUPROMOC']][$generalComboPrice['CDPRODPROMOCAO']]['CDPRODPROMOCAO']);
                }
            }

            $return = array(
				'error' => false,
				'data' => $finalComboPrices
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar precos de grupos promocionais. Erro: '.$e->getMessage()
			);
		}

        return $return;
    }

    public function getFamSaldProds($CDFILIAL){
        try{
            $params = array(
                'CDFILIAL' => $CDFILIAL
            );
    
            $famSaldProds = $this->connection->fetchAll(\Util\Query::GET_FAM_SALD_PRODS, $params);

            $indexFamSaldProd = [];

            foreach($famSaldProds as $famSaldProd){
                $indexFamSaldProd[$famSaldProd['CDPRODUTO']] = $famSaldProd['CDFAMILISALD'];
            }

            $return = array(
				'error' => false,
				'data' => $indexFamSaldProd
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos de familias de saldo. Erro: '.$e->getMessage()
			);
		}

        return $return;
    }

    public function getPreselectedProds($promoProd, $comboGroup){
      try{
        $params = array(
          ":CDPRODPROMOCAO" => $promoProd,
          ":CDGRUPROMOC" => $comboGroup
        );
  
        $preSelectedProds = $this->connection->fetchAll(\Util\Query::GET_IDPRODPRESELEC, $params);
  
        return array(
          'error' => false,
          'data'  => $preSelectedProds
        );
      } catch (\Exception $e) {
        return array(
          'error' => true,
          'message' => $e->getMessage()
        );
      }
    }

    public function getPreselectedProdsByBranch($subsidiaryCode, $promoProd, $comboGroup){
        try{
          $params = array(
            ":CDFILIAL"       => $subsidiaryCode,
            ":CDPRODPROMOCAO" => $promoProd,
            ":CDGRUPROMOC"    => $comboGroup
          );
    
          $preSelectedProds = $this->connection->fetchAll(\Util\Query::GET_IDPRODPRESELEC_BY_BRANCH, $params);
    
          return array(
            'error' => false,
            'data'  => $preSelectedProds
          );
        } catch (\Exception $e) {
          return array(
            'error' => true,
            'message' => $e->getMessage()
          );
        }
      }

    public function getMandatoryProds($promoProd, $comboGroup){
      try{
        $params = array(
          ":CDPRODPROMOCAO" => $promoProd,
          ":CDGRUPROMOC" => $comboGroup
        );
  
        $mandatoryProds = $this->connection->fetchAll(\Util\Query::GET_IDOBRPRODSELEC, $params);
  
        return array(
          'error' => false,
          'data'  => $mandatoryProds
        );
      } catch (\Exception $e) {
        return array(
          'error' => true,
          'message' => $e->getMessage()
        );
      }
    }

    public function getMandatoryProdsByBranch($subsidiaryCode, $promoProd, $comboGroup){
        try{
          $params = array(
            ":CDFILIAL"       => $subsidiaryCode,
            ":CDPRODPROMOCAO" => $promoProd,
            ":CDGRUPROMOC"    => $comboGroup
          );
    
          $mandatoryProds = $this->connection->fetchAll(\Util\Query::GET_IDOBRPRODSELEC_BY_BRANCH, $params);
    
          return array(
            'error' => false,
            'data'  => $mandatoryProds
          );
        } catch (\Exception $e) {
          return array(
            'error' => true,
            'message' => $e->getMessage()
          );
        }
    }

    public function getMainProducts($promoProd, $comboGroup){
      try{
        $params = array(
          ":CDPRODPROMOCAO" => $promoProd,
          ":CDGRUPROMOC" => $comboGroup
        );
  
        $mainProds = $this->connection->fetchAll(\Util\Query::GET_IDPRINCPROD, $params);
  
        return array(
          'error' => false,
          'data'  => $mainProds
        );
      } catch (\Exception $e) {
        return array(
          'error' => true,
          'message' => $e->getMessage()
        );
      }
    }

    public function getMainProductsByBranch($subsidiaryCode, $promoProd, $comboGroup){
        try{
          $params = array(
            ":CDFILIAL"       => $subsidiaryCode,
            ":CDPRODPROMOCAO" => $promoProd,
            ":CDGRUPROMOC"    => $comboGroup
          );
    
          $mainProds = $this->connection->fetchAll(\Util\Query::GET_IDPRINCPROD_BY_BRANCH, $params);
    
          return array(
            'error' => false,
            'data'  => $mainProds
          );
        } catch (\Exception $e) {
          return array(
            'error' => true,
            'message' => $e->getMessage()
          );
        }
      }

    public function buildMenu($groups, $subGroups, $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $productPrices, $comboPrices, $addProducts, $famSaldProds = []) {
        
        if(!empty($groups['data'])) {
            $groups = $groups['data'];
        } else {
            $groups = [];
        }

        if(!empty($subGroups['data'])) {
            $subGroups = $subGroups['data'];
        } else {
            $subGroups = [];
        }

        if(!empty($products['data'])) {
            $products = $products['data'];
        } else {
            $products = [];
        }

        if(!empty($observations['data'])) {
            $observations = $observations['data'];
        } else {
            $observations = [];
        }
        
        if(!empty($localComboGroups['data'])) {
            $localComboGroups = $localComboGroups['data'];
        } else {
            $localComboGroups = [];
        }

        if(!empty($comboGroups['data'])) {
            $comboGroups = $comboGroups['data'];
        } else {
            $comboGroups = [];
        }

        if(!empty($groupPromoProducts['data'])) {
            $groupPromoProducts = $groupPromoProducts['data'];
        } else{
            $groupPromoProducts = [];
        }

        if(!empty($productPrices['prices'])) {
            $productBasePrices = $productPrices['prices'];
        } else {
            $productBasePrices = [];
        }

        if(!empty($productPrices['dailyPrices'])) {
            $productDailyPrices = $productPrices['dailyPrices'];
        } else {
            $productDailyPrices = [];
        }

        if(!empty($comboPrices['data'])) {
            $comboPrices = $comboPrices['data'];
        } else {
            $comboPrices = [];
        }

        if(!empty($famSaldProds['data'])) {
            $famSaldProds = $famSaldProds['data'];
        } else {
            $famSaldProds = [];
        }

        $menu = [
            "groups"  => [],
            "combos" => [],
            "prices" => [
                "prices" => $productBasePrices,
                "dailyPrices" => $productDailyPrices,
                "comboDiffPrices" => $comboPrices
            ]
        ];

        foreach($groups as $group) {
            $groupImage = $group['DSENDEIMG'] != null ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM').$group['DSENDEIMG'] : null;
            $groupArray = [
                "groupName"        => $group['NMGRUPO'],
                "groupImage"       => $group['DSENDEIMG'],
                "groupImages"      => !empty($groupImage) ? $this->util->buildCachedImages(basename($groupImage)) : null,
                "groupCode"        => $group['NRBUTTON'],
                "groupDescription" => $group['DSITMENUVENDA'],
                "products"         => [],
                "groupIcon"        => $group['DSENDEIMGAUX'],
                "subGroups"        => []
            ];

            $groupArray['products'] = $this->buildGroupProducts($group['NRBUTTON'], $group['NRPGCONFTELA'], $group['IDTPBUTTON'], $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $addProducts, $famSaldProds);
            $groupArray['subGroups'] = $this->buildGroupSubGroups($group['NRBUTTON'], $group['NRPGCONFTELA'], $group['IDTPBUTTON'], $subGroups, $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $addProducts, $famSaldProds);

            array_push($menu['groups'], $groupArray);
        }

        foreach($localComboGroups as $localComboGroup){
          if(empty($menu['combos'][$localComboGroup['CDGRUPROMOC']])){
              $comboGroupArray = [
                  "comboGroupName" => $localComboGroup['NMGRUPROMOC'],
                  "comboGroupItems" => [],
              ];
  
              $comboGroupArray['comboGroupItems'] = $this->buildProductGroupItems($localComboGroup['CDGRUPROMOC'], $groupPromoProducts, $comboGroups, $localComboGroups, $observations, $addProducts, $famSaldProds);
              $menu['combos'][$localComboGroup['CDGRUPROMOC']] = $comboGroupArray;
          }
      }
        
        foreach($comboGroups as $comboGroup){
            if(empty($menu['combos'][$comboGroup['CDGRUPROMOC']])){
                $comboGroupArray = [
                    "comboGroupName" => $comboGroup['NMGRUPROMOC'],
                    "comboGroupItems" => [],
                ];
    
                $comboGroupArray['comboGroupItems'] = $this->buildProductGroupItems($comboGroup['CDGRUPROMOC'], $groupPromoProducts, $comboGroups, $localComboGroups, $observations, $addProducts, $famSaldProds);
                $menu['combos'][$comboGroup['CDGRUPROMOC']] = $comboGroupArray;
            }
        }
        
        return $menu;
    }

    public function buildGroupSubGroups($groupCode, $groupPgConfTela, $groupTpButton, $subGroups, $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $addProducts, $famSaldProds) {        

        $subGroupsArray = [];

        foreach($subGroups as $subGroup) {
          $subGroupImages = $subGroup['DSENDEIMG'] != null ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM').$subGroup['DSENDEIMG'] : null;
            $subGroupArray = [];
            
            if($subGroup['NRBUTTONAUX'] === $groupCode && 
               $subGroup['NRPGCONFTAUX'] === $groupPgConfTela &&
               $subGroup['IDTPBUTONAUX'] === $groupTpButton){
                $subGroupArray = [
                    "subGroupName"        => $subGroup['NMGRUPO'],
                    "subGroupImage"       => $subGroup['DSENDEIMG'],
                    "subGroupImages"      => !empty($subGroupImages) ? $this->util->buildCachedImages(basename($subGroupImages)) : null,
                    "subGroupCode"        => $subGroup['NRBUTTON'],
                    "subGroupDescription" => $subGroup['DSITMENUVENDA'],
                    "products"            => []
                ];
    
                $subGroupArray['products'] = $this->buildSubGroupProducts($subGroup['NRBUTTON'], $subGroup['NRPGCONFTELA'], $subGroup['IDTPBUTTON'], $groupCode, $groupPgConfTela, $groupTpButton, $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $addProducts, $famSaldProds);
    
                array_push($subGroupsArray, $subGroupArray);
            }
        }

        return $subGroupsArray;
    }

    public function buildGroupProducts($groupCode, $groupPgConfTela, $groupTpButton, $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $addProducts, $famSaldProds) {        

        $groupProducts = [];

        foreach($products as $product) {
            $groupProduct = [];

            if($product['NRBUTTONAUX'] === $groupCode && 
               $product['NRPGCONFTAUX'] === $groupPgConfTela && 
               $product['IDTPBUTONAUX'] === $groupTpButton) {
                $productImage = !empty($product['DSENDEIMG']) ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM') . $product['DSENDEIMG'] : null;
                $groupProduct = [
                    "productBarCode"        => $product['CDBARPRODUTO'],
                    "productCode"           => $product['CDPRODUTO'],
                    "productName"           => $product['DSBUTTON'],
                    "productDescription"    => $product['DESCRIPTION'],
                    "productImage"          => $productImage,
                    "productImages"         => $this->util->buildCachedImages(basename($productImage)),
                    "productPrint"          => $product['IDIMPPRODUTO'] == "1" ? "S" : "N",
                    "productShowOnMenu"     => !empty($product['IDEXIBEAPPCONS']) ? $product['IDEXIBEAPPCONS'] : 'S',
                    "productShowOrder"      => (!empty($product['NRPGCONFTELA']) && !empty($product['NRBUTTON'])) ? $product['NRPGCONFTELA'] . '|' . $product['NRBUTTON'] : '',
                    "productAddProducts"    => !empty($addProducts[$product['CDPRODUTO']]) ? $addProducts[$product['CDPRODUTO']] : [],
                    "creditFamily"          => !empty($famSaldProds[$product['CDPRODUTO']]) ? $famSaldProds[$product['CDPRODUTO']] : null,
                    "productGroups"         => [],
                    "observationsChoice"    => []
                ];

                $groupProduct['productGroups'] = $this->buildProductGroups($product['CDPRODUTO'], $comboGroups, $localComboGroups, $groupPromoProducts, $observations);
                $productObservations = $this->buildProductObservations($product['CDPRODUTO'], $observations);
                $groupProduct['observationsChoice'] = [];

                foreach ($productObservations as $productObservation){
                    array_push($groupProduct['observationsChoice'], $productObservation);
                }

                array_push($groupProducts, $groupProduct);
            }
        }

        return $groupProducts;
    }

    public function buildSubGroupProducts($subGroupCode, $subGroupPgConfTela, $subGroupTpButton, $groupCode, $groupPgConfTela, $groupTpButton, $products, $observations, $comboGroups, $localComboGroups, $groupPromoProducts, $addProducts, $famSaldProds) {        

        $subGroupProducts = [];

        foreach($products as $product) {
            $subGroupProduct = [];

            if($product['NRBUTTONAUX'] === $subGroupCode && 
               $product['NRPGCONFTAUX'] === $subGroupPgConfTela &&
               $product['IDTPBUTONAUX'] === $subGroupTpButton &&
               $product['NRBUTTONAUX2'] === $groupCode && 
               $product['NRPGCONFTAUX2'] === $groupPgConfTela &&
               $product['IDTPBUTONAUX2'] === $groupTpButton) {
                $productImage = !empty($product['DSENDEIMG']) ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM') . $product['DSENDEIMG'] : null;
                $subGroupProduct = [
                    "productBarCode"        => $product['CDBARPRODUTO'],
                    "productCode"           => $product['CDPRODUTO'],
                    "productName"           => $product['DSBUTTON'],
                    "productDescription"    => $product['DESCRIPTION'],
                    "productImage"          => $productImage,
                    "productImages"         => $this->util->buildCachedImages(basename($productImage)),
                    "productPrint"          => $product['IDIMPPRODUTO'] == "1" ? "S" : "N",
                    "productShowOnMenu"     => !empty($product['IDEXIBEAPPCONS']) ? $product['IDEXIBEAPPCONS'] : 'S',
                    "productShowOrder"      => (!empty($product['NRPGCONFTELA']) && !empty($product['NRBUTTON'])) ? $product['NRPGCONFTELA'] . '|' . $product['NRBUTTON'] : '',
                    "productAddProducts"    => !empty($addProducts[$product['CDPRODUTO']]) ? $addProducts[$product['CDPRODUTO']] : [],
                    "creditFamily"          => !empty($famSaldProds[$product['CDPRODUTO']]) ? $famSaldProds[$product['CDPRODUTO']] : null,
                    "productGroups"         => [],
                    "observationsChoice"    => []
                ];

                $subGroupProduct['productGroups'] = $this->buildProductGroups($product['CDPRODUTO'], $comboGroups, $localComboGroups, $groupPromoProducts, $observations);
                $productObservations = $this->buildProductObservations($product['CDPRODUTO'], $observations);
                $subGroupProduct['observationsChoice'] = [];

                foreach ($productObservations as $productObservation){
                    array_push($subGroupProduct['observationsChoice'], $productObservation);
                }

                array_push($subGroupProducts, $subGroupProduct);
            }
        }

        return $subGroupProducts;
    }

    public function buildProductObservations($CDPRODUTO, $observations) {
        $productObservations = [];

        foreach($observations as $observation) {
            $productObservation = [];

            if($observation['CDPRODUTOPAI'] === $CDPRODUTO) {
                if(empty($productObservations[$observation['CDGRPOCOR']])){
                    $productObservations[$observation['CDGRPOCOR']] = [
                        "obsGroupCode" => $observation['CDGRPOCOR'],
                        "obsGroupName" => $observation['DSGRPOCOR'],
                        "maxQuantity"  => (int)$observation['NRMAXOCORR'],
                        "minQuantity"  => (int)$observation['NRMINOCORR'],
                        "observations" => []
                    ];
                }

                $productObservation = [
                    "obsCode"        => $observation['CDOCORR'],
                    "obsProductCode" => $observation['CDPRODUTOOBS'],
                    "obsName"        => $observation['DSOCORR'],
                    "obsType"        => $observation['IDCONTROLAOBS'],
                    "obsPrintOnApp"  => $observation['IDEXIOBSAPPCONS']
                ];

                array_push($productObservations[$observation['CDGRPOCOR']]['observations'], $productObservation);
            }
        }

        return $productObservations;
    }

    public function buildProductGroups($CDPRODUTO, $comboGroups, $localComboGroups, $groupPromoProducts, $observations) {
        $productGroups = [];
        
        foreach($localComboGroups as $localComboGroup) {
            $productGroup = [];

            if($localComboGroup['CDPRODPROMOCAO'] === $CDPRODUTO) {
                $productGroup = [
                    "productGroupCode"  => $localComboGroup['CDGRUPROMOC'],
                    //"productGroupName"  => $localComboGroup['NMGRUPROMOC'],
                    "productGroupMin"   => intval($localComboGroup['QTPRGRUPROMIN']),
                    "productGroupMax"   => intval($localComboGroup['QTPRGRUPPROMOC']),
                    "productGroupMutex" => $localComboGroup['CDGRUPMUTEX'],
                    "productGroupPrint" => $localComboGroup['IDIMPGRPROMO'],
                    //"productGroupItems" => []
                ];

                array_push($productGroups, $productGroup);
            }
        }
        
        if(empty($productGroups)){
            foreach($comboGroups as $comboGroup) {
                $productGroup = [];

                if($comboGroup['CDPRODPROMOCAO'] === $CDPRODUTO) {
                    $productGroup = [
                        "productGroupCode"  => $comboGroup['CDGRUPROMOC'],
                        //"productGroupName"  => $comboGroup['NMGRUPROMOC'],
                        "productGroupMin"   => intval($comboGroup['QTPRGRUPROMIN']),
                        "productGroupMax"   => intval($comboGroup['QTPRGRUPPROMOC']),
                        "productGroupMutex" => $comboGroup['CDGRUPMUTEX'],
                        "productGroupPrint" => $comboGroup['IDIMPGRPROMO'],
                        //"productGroupItems" => []
                    ];

                    array_push($productGroups, $productGroup);
                }
            }
        }

        return $productGroups;
    }

    public function buildProductGroupItems($CDGRUPROMOC, $groupPromoProducts, $comboGroups, $localComboGroups, $observations, $addProducts, $famSaldProds) {
        $productGroupItems = [];

        foreach($groupPromoProducts as $groupPromoProduct) {
            $productGroupItem = [];

            if($groupPromoProduct['CDGRUPROMOC'] === $CDGRUPROMOC) {
                $productImage = !empty($groupPromoProduct['DSENDEIMG']) ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM') . $groupPromoProduct['DSENDEIMG'] : null;
                $productGroupItem = [
                    "subItemBarCode"            => $groupPromoProduct['CDBARPRODUTO'],
                    "subItemCode"               => $groupPromoProduct['CDPRODUTO'],
                    "subItemName"               => $groupPromoProduct['DSBUTTON'],
                    "subItemPreSelected"        => 'N',
                    "subItemProductGroups"      => [],
                    "subItemObservationsChoice" => [],
                    "subItemProductPrint"       => $groupPromoProduct['IDIMPPRODUTO'] == "1" ? "S" : "N",
                    "subItemShowOnMenu"         => !empty($groupPromoProduct['IDEXIBEAPPCONS']) ? $groupPromoProduct['IDEXIBEAPPCONS'] : 'S',
                    "subItemShowOrder"          => (!empty($groupPromoProduct['NRPGCONFTELA']) && !empty($groupPromoProduct['NRBUTTON'])) ? $groupPromoProduct['NRPGCONFTELA'] . '|' . $groupPromoProduct['NRBUTTON'] : '',
                    "subItemAddProducts"        => !empty($addProducts[$groupPromoProduct['CDPRODUTO']]) ? $addProducts[$groupPromoProduct['CDPRODUTO']] : [],
                    "subItemCreditFamily"       => !empty($famSaldProds[$groupPromoProduct['CDPRODUTO']]) ? $famSaldProds[$groupPromoProduct['CDPRODUTO']] : null,
                    "subItemProductImage"       => $productImage,
                    "subItemProductImages"      => $this->util->buildCachedImages(basename($productImage))
                ];

                $productGroupItem['subItemProductGroups'] = $this->buildSubItemProductGroups($groupPromoProduct['CDPRODUTO'], $comboGroups, $localComboGroups, $groupPromoProducts, $observations);
                $subItemObservations = $this->buildSubItemObservations($groupPromoProduct['CDPRODUTO'], $observations);
                $productGroupItem['subItemObservationsChoice'] = [];

                foreach ($subItemObservations as $subItemObservation){
                    array_push($productGroupItem['subItemObservationsChoice'], $subItemObservation);
                }

                array_push($productGroupItems, $productGroupItem);
            }
        }

        return $productGroupItems;
    }

    public function buildSubItemObservations($CDPRODUTO, $observations) {
        $subItemObservations = [];

        foreach($observations as $observation) {
            $subItemObservation = [];

            if($observation['CDPRODUTOPAI'] === $CDPRODUTO) {
                if(empty($subItemObservations[$observation['CDGRPOCOR']])){
                    $subItemObservations[$observation['CDGRPOCOR']] = [
                        "subItemObsGroupCode" => $observation['CDGRPOCOR'],
                        "subItemObsGroupName" => $observation['DSGRPOCOR'],
                        "maxQuantity"         => (int)$observation['NRMAXOCORR'],
                        "minQuantity"         => (int)$observation['NRMINOCORR'],
                        "subItemObservations" => []
                    ];
                }

                $subItemObservation = [
                    "subItemObsCode"        => $observation['CDOCORR'],
                    "subItemObsProductCode" => $observation['CDPRODUTOOBS'],
                    "subItemObsName"        => $observation['DSOCORR'],
                    "subItemObsType"        => $observation['IDCONTROLAOBS'],
                    "subItemObsPrintOnApp"  => $observation['IDEXIOBSAPPCONS']
                ];

                array_push($subItemObservations[$observation['CDGRPOCOR']]['subItemObservations'], $subItemObservation);
            }
        }

        return $subItemObservations;
    }

    public function buildSubItemProductGroups($CDPRODUTO, $comboGroups, $localComboGroups, $groupPromoProducts, $observations) {
        $subItemProductGroups = [];

        foreach($localComboGroups as $localComboGroup) {
            $subItemProductGroup = [];

            if($localComboGroup['CDPRODPROMOCAO'] === $CDPRODUTO) {
                $subItemProductGroup = [
                    "subProductGroupCode"  => $localComboGroup['CDGRUPROMOC'],
                    "subProductGroupName"  => $localComboGroup['NMGRUPROMOC'],
                    "subProductGroupMin"   => intval($localComboGroup['QTPRGRUPROMIN']),
                    "subProductGroupMax"   => intval($localComboGroup['QTPRGRUPPROMOC']),
                    "subProductGroupMutex" => $localComboGroup['CDGRUPMUTEX'],
                    "subProductGroupPrint" => $localComboGroup['IDIMPGRPROMO']
                ];
                
                array_push($subItemProductGroups, $subItemProductGroup);
            }
        }

        if(empty($subItemProductGroups)){
            foreach($comboGroups as $comboGroup) {
                $subItemProductGroup = [];

                if($comboGroup['CDPRODPROMOCAO'] === $CDPRODUTO) {
                    $subItemProductGroup = [
                        "subProductGroupCode"  => $comboGroup['CDGRUPROMOC'],
                        "subProductGroupName"  => $comboGroup['NMGRUPROMOC'],
                        "subProductGroupMin"   => intval($comboGroup['QTPRGRUPROMIN']),
                        "subProductGroupMax"   => intval($comboGroup['QTPRGRUPPROMOC']),
                        "subProductGroupMutex" => $comboGroup['CDGRUPMUTEX'],
                        "subProductGroupPrint" => $comboGroup['IDIMPGRPROMO']
                    ];
                    
                    array_push($subItemProductGroups, $subItemProductGroup);
                }
            }
        }

        return $subItemProductGroups;
    }

    public function formatPrice($price) {
        return bcadd($price, '0', 2);
    }

    public function getBloqProdsTAA($CDFILIAL, $CDLOJA) {
        try{
            $NRDIASEMANABLOQ = (string)((int)date('w') + 1);

            $params = array(
                ":CDFILIAL" => $CDFILIAL,
                ":CDLOJA" => $CDLOJA,
                ":NRDIASEMANABLOQ" => $NRDIASEMANABLOQ
            );

            $bloqProdsTAA = $this->connection->fetchAll(\Util\Query::GET_PRODBLOQVNDTAA, $params);

            $return = array(
				'error' => false,
				'data'  => $bloqProdsTAA
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos bloqueados no TAA. Erro: '.$e->getMessage()
			);
		}

        return $return;
    }

    public function getGeneralBloqProds($CDFILIAL, $CDLOJA) {
        try{
            $NRDIASEMANABLOQ = (string)((int)date('w') + 1);

            $params = array(
                ":CDFILIAL" => $CDFILIAL,
                ":CDLOJA" => $CDLOJA,
                ":NRDIASEMANABLOQ" => $NRDIASEMANABLOQ
            );

            $bloqProdsTAA = $this->connection->fetchAll(\Util\Query::GET_PRODBLOQVND, $params);

            $return = array(
				'error' => false,
				'data'  => $bloqProdsTAA
			);
        } catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos bloqueados. Erro: '.$e->getMessage()
			);
		}

        return $return;
    }

    public function buildBloqProds($bloqProdsTAA, $generalBloqProds) {
        $finalBloqProds = [];

        foreach($bloqProdsTAA['data'] as $bloqProdTAA){
            if(!in_array($bloqProdTAA['CDPRODUTO'], $finalBloqProds)){
                array_push($finalBloqProds, $bloqProdTAA['CDPRODUTO']);
            }
        }

        foreach($generalBloqProds['data'] as $generalBloqProd){
            if(!in_array($generalBloqProd['CDPRODUTO'], $finalBloqProds)){
                array_push($finalBloqProds, $generalBloqProd['CDPRODUTO']);
            }
        }

        return $finalBloqProds;
    }
    
    public function getGroupProducts($CDFILIAL, $CDCAIXA, $group, $CDLOJA) {
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA' => $CDCAIXA,
			'NRPGCONFTELA' => $group['NRPGCONFTELA'],
			'NRBUTTON' => $group['NRBUTTON'],
			'CDLOJA' => $CDLOJA
		);
		
		try {    	
			if($this->checkForConfTela()['error'] == false){
				$confTelaCaixa = $this->getConfTelaCaixa($CDFILIAL, $CDCAIXA);
				if(!empty($confTelaCaixa['data'])){
					$params['DTINIVIGENCIA'] = $confTelaCaixa['data'][0]['DTINIVIGENCIA'];
					if ($this->util->databaseIsOracle()) $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_GROUP_PRODUCTS_CONFTELACX, $params);
					else $products = $this->connection->fetchAll(\Util\Query::SQL_GET_GROUP_PRODUCTS_CONFTELACX, $params);
				} else {
					if ($this->util->databaseIsOracle()) $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_GROUP_PRODUCTS, $params);
					else $products = $this->connection->fetchAll(\Util\Query::SQL_GET_GROUP_PRODUCTS, $params);
				}
			} else {
				if ($this->util->databaseIsOracle()) $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_GROUP_PRODUCTS, $params);
				else $products = $this->connection->fetchAll(\Util\Query::SQL_GET_GROUP_PRODUCTS, $params);
			}
			$return = array(
				'error' => false,
				'data' => $products
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos do grupo. Erro: '.$e->getMessage()
			);
		}
		return $return;
	}
    
    public function getSubGroups($CDFILIAL, $CDCAIXA, $group) {
    	$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA' => $CDCAIXA,
			'NRPGCONFTELA' => $group['NRPGCONFTELA'],
			'NRBUTTON' => $group['NRBUTTON']
		);
		
		try {
			if($this->checkForConfTela()['error'] == false){
				$confTelaCaixa = $this->getConfTelaCaixa($CDFILIAL, $CDCAIXA);
				if(!empty($confTelaCaixa['data'])){
					
					$params['DTINIVIGENCIA'] = $confTelaCaixa['data'][0]['DTINIVIGENCIA'];
					
					$subGroup = $this->connection->fetchAll(\Util\Query::GET_SUBGROUPS_CONFTELACX, $params);
				} else {
					$subGroup = $this->connection->fetchAll(\Util\Query::GET_SUBGROUPS, $params);
				}
			} else {
				$subGroup = $this->connection->fetchAll(\Util\Query::GET_SUBGROUPS, $params);
			}
			
			$return = array(
				'error' => false,
				'data' => $subGroup
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar subgrupos do grupo. Erro: '.$e->getMessage()
			);
		}
		
		return $return;
    }

	public function getAllSubGroups($CDFILIAL, $CDCAIXA) {
    	$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA' => $CDCAIXA
		);
		
		try {
			$confTelaCaixa = $this->getConfTelaCaixa($CDFILIAL, $CDCAIXA);
			
			$params['DTINIVIGENCIA'] = $confTelaCaixa['data'][0]['DTINIVIGENCIA'];
			
			$subGroup = $this->connection->fetchAll(\Util\Query::GET_SUBGROUPS_CONFTELACX_NO_FILTER, $params);
							
			$return = array(
				'error' => false,
				'data' => $subGroup
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar subgrupos do grupo. Erro: '.$e->getMessage()
			);
		}
		
		return $return;
    }
    
    public function getSubGroupProducts($CDFILIAL, $CDCAIXA, $group, $subGroup, $CDLOJA) {
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA' => $CDCAIXA,
			'NRPGCONFTELA' => $subGroup['NRPGCONFTELA'],
			'NRBUTTON' => $subGroup['NRBUTTON'],
			'NRPGCONFTAUX' => $subGroup['NRPGCONFTAUX'],
			'NRBUTTONAUX' => $subGroup['NRBUTTONAUX'],
			'CDLOJA' => $CDLOJA
		);
		
		try {
			if($this->checkForConfTela()['error'] == false){
				$confTelaCaixa = $this->getConfTelaCaixa($CDFILIAL, $CDCAIXA);
				if(!empty($confTelaCaixa['data'])){
					$params['DTINIVIGENCIA'] = $confTelaCaixa['data'][0]['DTINIVIGENCIA'];
					if ($this->util->databaseIsOracle()) $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_SUBGROUP_PRODUCTS_CONFTELACX, $params);
					else $products = $this->connection->fetchAll(\Util\Query::SQL_GET_SUBGROUP_PRODUCTS_CONFTELACX, $params);
				} else {
					if ($this->util->databaseIsOracle()) $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_SUBGROUP_PRODUCTS, $params);
					else $products = $this->connection->fetchAll(\Util\Query::SQL_GET_SUBGROUP_PRODUCTS, $params);
				}
			} else {
				// verifica qual banco de dados está sendo utilizado
				if ($this->util->databaseIsOracle()) $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_SUBGROUP_PRODUCTS, $params);
				else $products = $this->connection->fetchAll(\Util\Query::SQL_GET_SUBGROUP_PRODUCTS, $params);
			}
			
			$return = array(
				'error' => false,
				'data' => $products
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar produtos do subgrupo. Erro: '.$e->getMessage()
			);
		}
		
		return $return;
	}

    public function checkProductObservations($productCode, $subsidiaryCode, $storeCode){
        $params = array(
            'CDFILIAL' => $subsidiaryCode,
            'CDLOJA' => $storeCode,
            'CDPRODUTO' => $productCode
        );
       
        try {
        	if ($this->util->databaseIsOracle()) {
       		 	$result = $this->connection->fetchAll(\Util\Query::ORACLE_GET_CHECK_PRODUCT_OBSERVATIONS, $params);
       	    } else {
       		 	$result = $this->connection->fetchAll(\Util\Query::SQL_GET_CHECK_PRODUCT_OBSERVATIONS, $params);
       	    }
	        return count($result) > 0;
		} catch (\Exception $e) {
			return false;
		}
		
    }
    
    public function getActivePrincingTable($CDFILIAL, $CDLOJA) {
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA' => $CDLOJA
        );
        
        try {

			$tabelaLoja = $this->connection->fetchAssoc(\Util\Query::STORE_PRICING_TABLE, $params);
			if($tabelaLoja && $tabelaLoja["CDTABEPREC"]) {
				$DTINIVGPRECLOJA = self::checkPrincingTable($CDFILIAL, $tabelaLoja["CDTABEPREC"]);
			}

			$tabelaParavend = $this->connection->fetchAssoc(\Util\Query::PARAVEND_PRICING_TABLE, $params);
			if($tabelaParavend && $tabelaParavend["CDTABEPREC"]) {
				$DTINIVGPRECPV = self::checkPrincingTable($CDFILIAL, $tabelaParavend["CDTABEPREC"]);
			}

            // verifica qual banco de dados está sendo utilizado
            if ($this->util->databaseIsOracle()) {
            	$tabelaGeral = $this->connection->fetchAssoc(\Util\Query::ORACLE_GET_PRICING_TABLE, $params);
            } else {
            	$tabelaGeral = $this->connection->fetchAssoc(\Util\Query::GET_PRICING_TABLE, $params);
            }

			$return = array(
				'error' => true,
				'message' => ""
			);
			switch(true){
				case ($tabelaLoja && $tabelaLoja["CDTABEPREC"] && $DTINIVGPRECLOJA):
					/* tabela de preço parametrizada na loja*/
					$return = array(
	                    'error' => false,
	                    'CDFILIAL' => $CDFILIAL,
	                    'CDTABEPREC' => $tabelaLoja["CDTABEPREC"],
	                    'DTINIVGPREC' => $DTINIVGPRECLOJA,
						'modo' => 'loja'
	                );

					break;
				case ($tabelaParavend && $tabelaParavend["CDTABEPREC"] && $DTINIVGPRECPV):
					$return = array(
						'error' => false,
						'CDFILIAL' => $CDFILIAL,
						'CDTABEPREC' => $tabelaParavend["CDTABEPREC"],
						'DTINIVGPREC' => $DTINIVGPRECPV,
						'modo' => 'paravend'
					);
					break;
				case ($tabelaGeral && $tabelaGeral["CDTABEPREC"]):
					$return = array(
						'error' => false,
						'CDFILIAL' => $CDFILIAL,
						'CDTABEPREC' => $tabelaGeral["CDTABEPREC"],
						'DTINIVGPREC' => $tabelaGeral['DTINIVGPREC'],
						'modo' => 'geral'
					);
					break;
				default:
					$return = array(
						'error' => true,
						'message' => 'Não foram encontradas as três modalidades de cadastro de tabela de preços: por loja, por parâmetros de venda e geral. Verifique a tabela TABEVENDGER e os campos CDTABEPREC da tabela PARAVEND E LOJA.'
					);
					break;
			}
	        
			// if ($tabelaLoja && $tabelaLoja["CDTABEPREC"]) {
	        //     $DTINIVGPREC = self::checkPrincingTable($CDFILIAL, $tabelaLoja["CDTABEPREC"]);
	        //     if (!$DTINIVGPREC) {
			// 		/* Caso tabela associada a loja esteja inativa, consulta PARAVEND . */
			// 		$tabelaParavend = $this->connection->fetchAssoc(\Util\Query::PARAVEND_PRICING_TABLE, $params);
			// 		if($tabelaParavend && $tabelaParavend["CDTABEPREC"]){
			// 			$DTINIVGPREC = self::checkPrincingTable($CDFILIAL, $tabelaParavend["CDTABEPREC"]);
			// 			if (!$DTINIVGPREC) {
			// 				/* Caso tabela associada a PARAVEND esteja inativa, consulta tabela geral. */
			// 				$tabelaGeral = $this->connection->fetchAssoc(\Util\Query::GET_PRICING_TABLE, $params);
			// 				if($tabelaGeral && $tabelaGeral["CDTABEPREC"]){
			// 					$return = array(
			// 						'error' => false,
			// 						'CDFILIAL' => $CDFILIAL,
			// 						'CDTABEPREC' => $tabelaGeral["CDTABEPREC"],
			// 						'DTINIVGPREC' => $tabelaGeral['DTINIVGPREC']
			// 					);
			// 				} else {
			// 					$return = array(
			// 						'error' => true,
			// 						'message' => 'Não há tabela de preços geral e tabela de preços cadastrada para os parâmetros da venda da filial. Verifique a tabela TABEVENDGER e o campo CDTABEPREC da tabela PARAVEND.'
			// 					);
			// 				}
			// 			} else {
			// 				$return = array(
			// 					'error' => false,
			// 					'CDFILIAL' => $CDFILIAL,
			// 					'CDTABEPREC' => $tabelaParavend["CDTABEPREC"],
			// 					'DTINIVGPREC' => $DTINIVGPREC
			// 				);
			// 			}	
			// 		} else {	
			// 			$tabelaGeral = $this->connection->fetchAssoc(\Util\Query::GET_PRICING_TABLE, $params);
			// 			if($tabelaGeral && $tabelaGeral["CDTABEPREC"]){
			// 				$return = array(
			// 					'error' => false,
			// 					'CDFILIAL' => $CDFILIAL,
			// 					'CDTABEPREC' => $tabelaGeral["CDTABEPREC"],
			// 					'DTINIVGPREC' => $tabelaGeral['DTINIVGPREC']
			// 				);
			// 			} else {
			// 				$return = array(
			// 					'error' => true,
			// 					'message' => 'Não há tabela de preços geral e tabela de preços cadastrada para a loja. Verifique a tabela TABEVENDGER e o campo CDTABEPREC da tabela LOJA.'
			// 				);
			// 			}
			// 		}
	        //     } else {
	        //         $return = array(
	        //             'error' => false,
	        //             'CDFILIAL' => $CDFILIAL,
	        //             'CDTABEPREC' => $tabelaLoja["CDTABEPREC"],
	        //             'DTINIVGPREC' => $DTINIVGPREC
	        //         );
	        //     }
			// } else {	
			// 	$tabelaGeral = $this->connection->fetchAssoc(\Util\Query::GET_PRICING_TABLE, $params);
			// 	if($tabelaGeral && $tabelaGeral["CDTABEPREC"]){
			// 		$return = array(
			// 			'error' => false,
			// 			'CDFILIAL' => $CDFILIAL,
			// 			'CDTABEPREC' => $tabelaGeral["CDTABEPREC"],
			// 			'DTINIVGPREC' => $tabelaGeral['DTINIVGPREC']
			// 		);
			// 	} else {
			// 		$return = array(
			// 			'error' => true,
			// 			'message' => 'Não há tabela de preços geral e tabela de preços cadastrada para a loja. Verifique a tabela TABEVENDGER e o campo CDTABEPREC da tabela LOJA.'
			// 		);
			// 	}
			// }
        } catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar tabela de preços. Erro: '.$e->getMessage()
            );
        }
        
        return $return;
	}

	public function checkPrincingTable($CDFILIAL, $CDTABEPREC) {
        // valida vigência
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':CDTABEPREC' => $CDTABEPREC
        );


        // verifica qual banco de dados está sendo utilizado
        if ($this->util->databaseIsOracle()) {
        	$return = $this->connection->fetchAssoc(\Util\Query::ORACLE_TABELA_VENDA, $params);
        } else {
        	$return = $this->connection->fetchAssoc(\Util\Query::SQL_TABELA_VENDA, $params);
        }

        if ($return) {
            return $return["DTINIVGPREC"];
        } else {
            return false;
        }
    }
    
    public function getPrices($CDFILIAL, $CDTABEPREC, $DTINIVGPREC, $CDTIPOCONSPD, $timeOfDay, $isCombo) {
		$currentDate = new \DateTime();
		$params = array(
            'CDFILIAL' => $CDFILIAL,
            'DTFERIFILI' => $currentDate->format('d/m/Y')
        );
        if ($this->util->databaseIsOracle()) {
            $return = $this->connection->fetchAssoc(\Util\Query::ORACLE_HOLIDAY, $params);
        } else {
            $return = $this->connection->fetchAssoc(\Util\Query::SQL_HOLIDAY, $params);
        }
        if ($return) {
 			$day = 'F';
        } else {
            $day = $currentDate->format('N') % 7 + 1;
        }
		$params = array(
	        'CDFILIAL' => $CDFILIAL,
	        'CDTABEPREC' => $CDTABEPREC,
	        'DTINIVGPREC' => $DTINIVGPREC,
	        'CDTIPOCONSPD' => $CDTIPOCONSPD,
	        'DAYOFWEEK' => strval($day),
	        'TIMEOFDAY' => $timeOfDay
	    );
	    try {
		    if ($this->util->databaseIsOracle()) {
				if($isCombo === true)
					$prices = $this->connection->fetchAll(\Util\Query::ORACLE_GET_PRICES_COMBOS, $params);
				else
					$prices = $this->connection->fetchAll(\Util\Query::ORACLE_GET_PRICES, $params);
	        } else {
				if($isCombo === true)
					$prices = $this->connection->fetchAll(\Util\Query::SQL_GET_PRICES_COMBOS, $params);
				else
					$prices = $this->connection->fetchAll(\Util\Query::SQL_GET_PRICES, $params);
	        }
			if(empty($prices)){
				if ($this->util->databaseIsOracle()) {
					if($isCombo === true)
						$prices = $this->connection->fetchAll(\Util\Query::ORACLE_GET_PRICES_COMBOS_GERAL, $params);
					else
						$prices = $this->connection->fetchAll(\Util\Query::ORACLE_GET_PRICES_GERAL, $params);
				} else {
					if($isCombo === true)
						$prices = $this->connection->fetchAll(\Util\Query::SQL_GET_PRICES_COMBOS_GERAL, $params);
					else
						$prices = $this->connection->fetchAll(\Util\Query::SQL_GET_PRICES_GERAL, $params);
				}
			}
	        if (!empty($prices)) {
	    		$indexedPrices = array();
	            foreach ($prices as $product) {
	            	$indexedProduct = !empty($indexedPrices[$product['CDPRODUTO']]) ? $indexedPrices[$product['CDPRODUTO']] : null;
	            	if(!empty($indexedProduct)){
	            		if($indexedProduct['NRDIASEMANPR'] == 'T'){
	                		$indexedPrices[$product['CDPRODUTO']] = $product;
	            		}
	            	}
	            	else
            			$indexedPrices[$product['CDPRODUTO']] = $product;
				}
	            $return = array(
	                'error' => false,
	                'data' => $indexedPrices
	            );
	        } else {
	            $return = array(
	                'error' => true,
	                'message' => 'Não há produtos para a tabela de preços vigente.'
	            );
	        }
	    } catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar os preços dos produtos da tabela de preços da loja '.$CDFILIAL.'. Erro: '.$e->getMessage()
            );
        }
        return $return;
	}

    public function getObservationsByProduct($CDGRPOCOR, $CDPRODUTO, $CDFILIAL, $CDLOJA){
        $params = array(
            'CDGRPOCOR' => $CDGRPOCOR,
            'CDPRODUTO' => $CDPRODUTO,
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA' => $CDLOJA	
        );
        try {
        	if ($this->util->databaseIsOracle()) {
	            $observations = $this->connection->fetchAll(\Util\Query::ORACLE_GET_PRODUCT_OBSERVATIONS, $params);
	        } else {
	            $observations = $this->connection->fetchAll(\Util\Query::SQL_GET_PRODUCT_OBSERVATIONS, $params);
	        }
 			$return = array(
	            'error' => false,
	            'data' => $observations
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar observacoes do produto. Erro: '.$e->getMessage()
            );
        } 
        return $return;
    }

    public function getObservationGroups($CDFILIAL, $CDLOJA){
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA' => $CDLOJA
        );
        try {
		    if ($this->util->databaseIsOracle()) {
	            $groups = $this->connection->fetchAll(\Util\Query::ORACLE_GET_STORE_OBSERVATIONS_GROUPS, $params);
	        } else {
	            $groups = $this->connection->fetchAll(\Util\Query::SQL_GET_STORE_OBSERVATIONS_GROUPS, $params);
	        }
 			$return = array(
	            'error' => false,
	            'data' => $groups
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar grupos de observacoes. Erro: '.$e->getMessage()
            );
        } 

        return $return;
    }

	public function getObservationGroupsEx($CDFILIAL, $CDLOJA){
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA' => $CDLOJA
        );
        try {
		    if ($this->util->databaseIsOracle()) {
	            $groups = $this->connection->fetchAll(\Util\Query::ORACLE_GET_STORE_OBSERVATIONS_GROUPS_EX, $params);
	        } else {
	            $groups = $this->connection->fetchAll(\Util\Query::SQL_GET_STORE_OBSERVATIONS_GROUPS_EX, $params);
	        }
 			$return = array(
	            'error' => false,
	            'data' => $groups
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar grupos de observacoes. Erro: '.$e->getMessage()
            );
        } 

        return $return;
    }

    public function getComboGroupsBySubsidiary($CDFILIAL, $CDIDENTBUTON){
    	$params = array(
            'CDFILIAL' => $CDFILIAL,
            'CDIDENTBUTON' => $CDIDENTBUTON
        );
        try {
      		$groups = $this->connection->fetchAll(\Util\Query::SQL_GET_COMBO_GROUPS_SUBSIDIARY, $params);
 			$return = array(
	            'error' => false,
	            'data' => $groups
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar grupos de combo do produto. Erro: '.$e->getMessage()
            );
        } 

        return $return;
    }

    public function getComboGroupsByProduct($CDIDENTBUTON){
    	$params = array(
            'CDIDENTBUTON' => $CDIDENTBUTON
        );
        try {
      		$groups = $this->connection->fetchAll(\Util\Query::SQL_GET_COMBO_GROUPS_PRODUCT, $params);
 			$return = array(
	            'error' => false,
	            'data' => $groups
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar grupos de combo do produto. Erro: '.$e->getMessage()
            );
        } 

        return $return;
    }

    public function getComboProductsBySubsidiary($CDFILIAL, $CDLOJA, $CDGRUPROMOC, $CDIDENTBUTON){
    	$params = array(
            'CDGRUPROMOC' => $CDGRUPROMOC,
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA' => $CDLOJA,
            'CDIDENTBUTON' => $CDIDENTBUTON
        );
        try {
      		if ($this->util->databaseIsOracle()) {
	            $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_COMBO_PRODUCTS_SUBSIDIARY, $params);
	        } else {
	            $products = $this->connection->fetchAll(\Util\Query::SQL_GET_COMBO_PRODUCTS_SUBSIDIARY, $params);
	        }
 			$return = array(
	            'error' => false,
	            'data' => $products
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar produtos do combo. Erro: '.$e->getMessage()
            );
        } 
        return $return;
    }

    public function getComboProductsByProduct($CDFILIAL, $CDLOJA, $CDGRUPROMOC, $CDIDENTBUTON, $pricingTableCode){
		$params = array(
            'CDGRUPROMOC' => $CDGRUPROMOC,
            'CDFILIAL' => $CDFILIAL,
            'CDLOJA' => $CDLOJA,
            'CDIDENTBUTON' => $CDIDENTBUTON,
            'CDTABEPREC' => $pricingTableCode
        );
        try {
		    if ($this->util->databaseIsOracle()) {
	            $products = $this->connection->fetchAll(\Util\Query::ORACLE_GET_COMBO_PRODUCTS_PRODUCT, $params);
	        } else {
	            $products = $this->connection->fetchAll(\Util\Query::SQL_GET_COMBO_PRODUCTS_PRODUCT, $params);
	        }
 			$return = array(
	            'error' => false,
	            'data' => $products
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar produtos do combo. Erro: '.$e->getMessage()
            );
        } 
        return $return;
	}

	public function getComboGroupsBySubsidiaryDiscount($CDFILIAL, $CDIDENTBUTON){
    	$params = array(
            'CDFILIAL' => $CDFILIAL,
            'CDIDENTBUTON' => $CDIDENTBUTON
        );
        try {
      		$groups = $this->connection->fetchAll(\Util\Query::SQL_GET_COMBO_GROUPS_SUBSIDIARY_DISCOUNT, $params);
 			$return = array(
	            'error' => false,
	            'data' => $groups
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar grupos de combo do produto. Erro: '.$e->getMessage()
            );
        } 

        return $return;
	}
	
	public function getComboGroupsByProductDiscount($CDIDENTBUTON){
    	$params = array(
            'CDIDENTBUTON' => $CDIDENTBUTON
        );
        try {
      		$groups = $this->connection->fetchAll(\Util\Query::SQL_GET_COMBO_GROUPS_PRODUCT_DISCOUNT, $params);
 			$return = array(
	            'error' => false,
	            'data' => $groups
	        );
 		}catch (\Exception $e) {
        	$return = array(
                'error' => true,
                'message' => 'Erro ao buscar grupos de combo do produto. Erro: '.$e->getMessage()
            );
        } 

        return $return;
    }
    
    public function getWaitingTime($CDFILIAL, $CDLOJA){
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDLOJA'   => $CDLOJA
		);
		try {
		   	$time = $this->connection->fetchAssoc(\Util\Query::GET_WAITING_TIME, $params);
		   	$return = array(
				'error' => false,
			    'data' => $time
		  	);
	    } catch (\Exception $e) {
		    $return = array(
				'error' => true,
			    'message' => 'Erro ao buscar tempo de espera. Erro: '.$e->getMessage()
   		    );
		}
		return $return;
	}

	public function getStoreWaitingTime($CDFILIAL, $CDLOJA){
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDLOJA'   => $CDLOJA
		);
		try {
		   	$time = $this->connection->fetchAssoc(\Util\Query::GET_STORE_WAITING_TIME, $params);
		   	$return = array(
				'error' => false,
			    'data' => $time
		  	);
	    } catch (\Exception $e) {
		    $return = array(
				'error' => true,
			    'message' => 'Erro ao buscar tempo de espera da loja. Erro: '.$e->getMessage()
   		    );
		}
		return $return;
	}

	public function checkForConfTela(){
		try {
			$checkForConfTela = $this->connection->fetchAssoc(\Util\Query::CHECK_FOR_CONFTELA);
			$return = array(
				'error' => false,
				'data' => $checkForConfTela
			);
		} catch (\Exception $e){
			$return = array(
				'error' => true,
			    'message' => 'Erro ao buscar a tabela CONFTELACAIXA. Erro: '.$e->getMessage()
   		    );
		}
		return $return;
	}

	public function getConfTelaCaixa($CDFILIAL, $CDCAIXA){
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA'   => $CDCAIXA
		);
		try {
			$confTelaCaixa = $this->connection->fetchAll(\Util\Query::GET_CONFTELA_CAIXA, $params);
			$return = array(
				'error' => false,
				'data' => $confTelaCaixa
			);
		} catch (\Exception $e){
			$return = array(
				'error' => true,
			    'message' => 'Erro ao buscar a configuração da tela do caixa. Erro: '.$e->getMessage()
   		    );
		}
		return $return;
	}

    public function getConfTelaCaixaEx($CDFILIAL, $CDCAIXA){
		$params = array(
			'CDFILICAIXA' => $CDFILIAL,
			'CDCAIXA'   => $CDCAIXA
		);
		try {
			$confTelaCaixa = $this->connection->fetchAll(\Util\Query::GET_CONFTELA_CAIXA_EX, $params);
			$return = array(
				'error' => false,
				'data' => $confTelaCaixa[0]
			);
		} catch (\Exception $e){
			$return = array(
				'error' => true,
			    'message' => 'Erro ao buscar a configuração da tela do caixa. Erro: '.$e->getMessage()
   		    );
		}
		return $return;
	}

    public function getConfTelaCaixaTaa(){
        try{
            $confTelas = $this->connection->fetchAll(\Util\Query::GET_CONFTELA_CAIXA_TAA_TAP);
            $data = [];
            if(!empty($confTelas)){
                foreach($confTelas as $confTela){
                    array_push($data, $confTela['NRCONFTELA']);
                }
            }else{
                throw new \Exception("Nenhum layout encontrado");            
            }
    
            $return = [
                'error' => false,
                'data' 	=> $data
              ];
            
        }catch(\Exception $e){
            $return = [
                'error'   => true,
                'message' => "Erro ao buscar os cardapios na base. Erro: " . $e->getMessage()
              ];
        }
        return $return;
      }

    public function getAvailableGroups() {
        try {

            $data = $this->connection->fetchAll(\Util\Query::GET_AVAILABLE_GROUPS);

            $return = [
            'error' => false,
            'data' 	=> $data
            ];
        } catch (\Exception $e){
            $return = [
            'error'   => true,
                'message' => "Erro ao buscar os grupos parametrizados na base. Erro: " . $e->getMessage()
            ];
        }

        return $return;
    }

  public function getAvailableSubGroups() {
      try {

          $data = $this->connection->fetchAll(\Util\Query::GET_AVAILABLE_SUBGROUPS);

          $return = [
            'error' => false,
            'data' 	=> $data
          ];
      } catch (\Exception $e){
            $return = [
              'error'   => true,
                'message' => "Erro ao buscar os subgrupos parametrizados na base. Erro: " . $e->getMessage()
            ];
      }

      return $return;
  }

  public function getAvailableProducts($conftelacaixa) {
        try {
            $params = array(
                'ARRAYLAYOUTS' => $conftelacaixa
            );
            $types = array(
                'ARRAYLAYOUTS' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
            );
            $data = $this->connection->fetchAll(\Util\Query::GET_AVAILABLE_PRODUCTS, $params,$types);

            $return = [
                'error' => false,
                'data' 	=> $data
            ];
		} catch (\Exception $e){
        $return = [
          'error'   => true,
            'message' => "Erro ao buscar os produtos parametrizados na base. Erro: " . $e->getMessage()
        ];
		}
		  return $return;
  }

	public function getAvailablePosFromSubsidiary() {

		$params = [];

		try {
			$data = $this->connection->fetchAll(\Util\Query::SQL_GET_AVAILABLE_POS_FROM_SUBSIDIARY, $params);

			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => 'Erro ao buscar a configuração da tela do caixa. Erro: ' . $e->getMessage()
			];
		}

		return $return;
	}

	public function getSubProductsGroups($CDPRODPROMOCAO, $CDFILIAL){
		$params = [
			':CDPRODPROMOCAO' => $CDPRODPROMOCAO,
			':CDFILIAL' => $CDFILIAL
		];

		try {
			$data = $this->connection->fetchAll(\Util\Query::GET_PROMOTIONAL_GROUPS_MENU_LOCAL, $params);

			if(empty($data)){
				$data = $this->connection->fetchAll(\Util\Query::GET_PROMOTIONAL_GROUPS_MENU, $params);
			}

			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => "Erro ao buscar os grupos promocionais do produto $CDPRODPROMOCAO. Erro: " . $e->getMessage()
			];
		}

		return $return;
	}

	public function getSubProducts($CDFILIAL, $NRCONFTELA, $CDPRODPROMOCAO, $NRSEQGRPROMO, $CDGRUPROMOC){
		$params = [
			':CDFILIAL' 	  => $CDFILIAL,
			':NRCONFTELA'	  => $NRCONFTELA,
			':CDPRODPROMOCAO' => $CDPRODPROMOCAO,
			':NRSEQGRPROMO'	  => $NRSEQGRPROMO,
			':CDGRUPROMOC'	  => $CDGRUPROMOC
		];

		try {
			$desc = $this->connection->fetchAll(\Util\Query::GET_DESC_PROD_FILI, $params);
			if(empty($desc)){
				$data = $this->connection->fetchAll(\Util\Query::GET_PRODUCTS_PROM_GROUPS_MENU, $params);
			} else {
				$data = $this->connection->fetchAll(\Util\Query::GET_PRODUCTS_PROM_GROUPS_MENU_FILI, $params);
			}
			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => "Erro ao buscar os subprodutos do grupo promocional $CDGRUPROMOC do produto $CDPRODPROMOCAO. Erro: " . $e->getMessage()
			];
		}

		return $return;
	}

	public function getSubProductsNoPromCode($CDFILIAL, $NRCONFTELA, $NRSEQGRPROMO, $CDGRUPROMOC){
		$params = [
			':CDFILIAL' 	  => $CDFILIAL,
			':NRCONFTELA'	  => $NRCONFTELA,
			':NRSEQGRPROMO'	  => $NRSEQGRPROMO,
			':CDGRUPROMOC'	  => $CDGRUPROMOC
		];

		try {
			$data = $this->connection->fetchAll(\Util\Query::GET_PRODUCTS_PROM_GROUPS_MENU_NO_PROM_CODE, $params);

			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => "Erro ao buscar os subprodutos do grupo promocional $CDGRUPROMOC de sequencial $NRSEQGRPROMO. Erro: " . $e->getMessage()
			];
		}

		return $return;
	}

	public function getProductsPrinterParams($CDFILIAL, $CDLOJA){
		$params = [
			':CDFILIAL' 	  => $CDFILIAL,
			':CDLOJA'		  => $CDLOJA
		];

		try {
			$data = $this->connection->fetchAll(\Util\Query::GET_PRODUCTS_PRINTER_PARAMS, $params);

			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => "Erro ao buscar os parâmetros de impressora dos produtos. Erro: " . $e->getMessage()
			];
		}

		return $return;
	}

	public function getPosTefData($CDFILIAL, $CDLOJA) {
		$params = [
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA'	=> $CDLOJA
		];

		try {
			$data = $this->connection->fetchAll(\Util\Query::GET_POS_TEF_DATA, $params);

			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => "Erro ao buscar os dados do TEF dos caixas. Erro: " . $e->getMessage()
			];
		}
		return $return;
	}

	public function getPaymentsLayout($CDFILIAL, $CDCAIXA) {
		$params = array(
			'CDFILIAL' => $CDFILIAL,
			'CDCAIXA' => $CDCAIXA
		);
		try {
			if($this->checkForConfTela()['error'] == false){
				$confTelaCaixa = $this->getConfTelaCaixa($CDFILIAL, $CDCAIXA);
				if(!empty($confTelaCaixa['data'])){
					$params['DTINIVIGENCIA'] = $confTelaCaixa['data'][0]['DTINIVIGENCIA'];
					$payments = $this->connection->fetchAll(\Util\Query::GET_PAYMENTS_LAYOUT_CONFTE, $params);
				} else {
					$payments = $this->connection->fetchAll(\Util\Query::GET_PAYMENTS_LAYOT_CAIX, $params);
				}
			} else {
				$payments = $this->connection->fetchAll(\Util\Query::GET_PAYMENTS_LAYOT_CAIX, $params);
			}
			if(empty($payments)) throw new \Exception("Não foram encontrados tipos de recebimentos para esta filial/caixa.");
			$return = array(
				'error' => false,
				'data'  => $payments
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar tipos de recebimento por layout. Erro: '.$e->getMessage()
			);
		}
		return $return;
	}

	public function getPayments() {
		$params = array(
		);
		try {
			$payments = $this->connection->fetchAll(\Util\Query::GET_PAYMENTS_SHOWABLE, $params);
			if(empty($payments)) throw new \Exception("Não foram encontrados tipos de recebimentos para esta filial.");
			$return = array(
				'error' => false,
				'data'  => $payments
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar tipos de recebimento. Erro: '.$e->getMessage()
			);
		}
		return $return;
	}

    public function getProductSuggestion($CDFILIAL, $cdcaixa, $produtos) {
		$params = array(
            'CDFILIAL' => $CDFILIAL,
            'CDCAIXA' => $cdcaixa,
            'ARRAYPRODUTOS' => $produtos
		);
        $types = array(
            'CDFILIAL'    => \PDO::PARAM_STR,
            'CDCAIXA'  => \PDO::PARAM_STR,
            'ARRAYPRODUTOS' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
        );
		try {
			$payments = $this->connection->fetchAll(\Util\Query::BUSCA_ITENS_SUGESTAO, $params, $types);
			$return = array(
				'error' => false,
				'data'  => $payments
			);
		} catch (\Exception $e) {
			$return = array(
				'error' => true,
				'message' => 'Erro ao buscar sugestão de venda. Erro: '.$e->getMessage()
			);
		}
		return $return;
	}

    public function insertBloqProd($cdfilial, $cdloja, $cdoperador, $cdproduto, $nrorg) {
		$params = array(
			'CDFILIAL' => $cdfilial,
			'CDLOJA' => $cdloja,
            'CDOPERADOR' => $cdoperador,
            'CDPRODUTO' => $cdproduto,
            'NRORG'     => $nrorg
		);
		return $this->connection->executeQuery(\Util\Query::INSERT_PRODBLOQVNDTAA, $params);
    }

    public function deleteBloqProdTAA($cdfilial, $cdloja, $cdproduto) {
		$params = array(
			'CDFILIAL' => $cdfilial,
			'CDLOJA' => $cdloja,
            'CDPRODUTO' => $cdproduto
		);
        
        return $this->connection->executeQuery(\Util\Query::DELETE_PRODBLOQVNDTAA, $params);
    }

    public function deleteBloqProdVND($cdfilial, $cdloja, $cdproduto) {
		$params = array(
			'CDFILIAL' => $cdfilial,
			'CDLOJA' => $cdloja,
            'CDPRODUTO' => $cdproduto
		);
        
        return $this->connection->executeQuery(\Util\Query::DELETE_PRODBLOQVND, $params);
    }

    public function removeProductsWithoutPrice ($cdfilial){
        $params = array(
            'CDFILIAL' => $cdfilial
        );
        return $this->connection->fetchAssoc(\Util\Query::EXIBE_PRECO_ZERO, $params);
    }

    public function getWeightProducts($nrConfTela, $subsidiaryCode, $storeCode, $clientCode, $consumerType){
		$params = [
			':NRCONFTELA' => $nrConfTela
		];

		try {
			$products = $this->connection->fetchAll(\Util\Query::GET_WEIGHT_PRODUCTS, $params);
            $productsCode = [];
            foreach($products as $productCode){
                if(!in_array($productCode['CDPRODUTO'], $productsCode)){
                    array_push($productsCode, $productCode['CDPRODUTO']);
                }
            }

            $productPrices = $this->getProductPrices($subsidiaryCode, $storeCode, $clientCode, $consumerType, $products);
            $groupsCode = [];
            
            foreach($products as $group){
                if(!in_array($group['NRBUTTONAUX'], $groupsCode)){
                    array_push($groupsCode, $group['NRBUTTONAUX']);
                }
            }
            unset($params);
            $params = array(
                ':NRCONFTELA' => $nrConfTela,
                ':ARR' => $groupsCode
            );
    
            $types = [
                ':ARR' => \Doctrine\DBAL\Connection::PARAM_STR_ARRAY
            ];
            
            $groups = $this->connection->fetchAll(\Util\Query::GET_GROUPS_WEIGHT_PRODUCTS, $params, $types);
            $subGroups = $this->connection->fetchAll(\Util\Query::GET_SUBGROUPS_WEIGHT_PRODUCTS, $params, $types);
            $layout = [];

            foreach($groups as $group){
                $groupImage = $group['DSENDEIMG'] != null ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM').$group['DSENDEIMG'] : null;
                $groupArray = [
                    "groupName"        => $group['NMGRUPO'],
                    "groupImage"       => $group['DSENDEIMG'],
                    "groupImages"      => !empty($groupImage) ? $this->util->buildCachedImages(basename($groupImage)) : null,
                    "groupCode"        => $group['NRBUTTON'],
                    "groupDescription" => $group['DSITMENUVENDA'],
                    "products"         => [],
                    "groupIcon"        => $group['DSENDEIMGAUX'],
                    "subGroups"        => []
                ];

                foreach($products as $product){
                    if($product['NRBUTTONAUX'] == $group['NRBUTTON'] && $product['IDTPBUTONAUX'] == $group['IDTPBUTTON']){                  
                        $productImage = !empty($product['DSENDEIMG']) ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM') . $product['DSENDEIMG'] : null;
                        $groupProduct = [
                            "productBarCode"        => $product['CDBARPRODUTO'],
                            "productCode"           => $product['CDPRODUTO'],
                            "productName"           => $product['DSBUTTON'],
                            "productDescription"    => $product['DESCRIPTION'],
                            "productImage"          => $productImage,
                            "productImages"         => $this->util->buildCachedImages(basename($productImage)),
                            "productPrint"          => 'S',
                            "productShowOnMenu"     => !empty($product['IDEXIBEAPPCONS']) ? $product['IDEXIBEAPPCONS'] : 'S',
                            "productShowOrder"      => (!empty($product['NRPGCONFTELA']) && !empty($product['NRBUTTON'])) ? $product['NRPGCONFTELA'] . '|' . $product['NRBUTTON'] : '',
                            "productAddProducts"    => [],
                            "creditFamily"          => null,
                            "productGroups"         => [],
                            "observationsChoice"    => [],
                            "fullPrice"             => 0,
                            "price"                 => 0,
                            "discount"              => 0,
                            "addition"              => 0
                        ];

                        // Base price
                        $groupProduct['fullPrice'] = (!empty($productPrices['prices'][$groupProduct['productCode']]['PRECO']) ? $productPrices['prices'][$groupProduct['productCode']]['PRECO'] : 0.01);
                        $groupProduct['price'] = $groupProduct['fullPrice'];
        
                        //Daily price
                        if(!empty($productPrices['dailyPrices'][$groupProduct['productCode']])){
                            if($productPrices['dailyPrices'][$groupProduct['productCode']]['IDDESCACREPR'] === 'D'){
                                if($productPrices['dailyPrices'][$groupProduct['productCode']]['IDPERVALORPR'] === 'V'){
                                $groupProduct['price'] -= $productPrices['dailyPrices'][$groupProduct['productCode']]['VRPRECODIA'];
                                } else{
                                $groupProduct['price'] -= ($groupProduct['price'] * ($productPrices['dailyPrices'][$groupProduct['productCode']]['VRPRECODIA'] / 100));
                                }
                            } else{
                                if($productPrices['dailyPrices'][$product['productCode']]['IDPERVALORPR'] === 'V'){
                                $groupProduct['price'] += $productPrices['dailyPrices'][$product['productCode']]['VRPRECODIA'];
                                } else{
                                $groupProduct['price'] += ($groupProduct['price'] * ($productPrices['dailyPrices'][$groupProduct['productCode']]['VRPRECODIA'] / 100));
                                }
                            }
                        }
                        
                        $groupProduct['price'] = floatval(bcadd((string)$groupProduct['price'], '0.00', 2));
                        $groupProduct['discount'] = floatval(bcsub((string)$groupProduct['fullPrice'], $groupProduct['price'], 2));
                        if($groupProduct['discount'] < 0.00){
                            $groupProduct['addition'] = -1 * $groupProduct['discount'];
                            $groupProduct['discount'] = 0.0;
                        } else{
                            $groupProduct['addition'] = 0.0;
                        }

                        array_push($groupArray['products'], $groupProduct);
                    }
                }

                foreach($subGroups as $subGroup){
                    if($subGroup['NRBUTTONAUX'] == $group['NRBUTTON'] && $subGroup['IDTPBUTONAUX'] == $group['IDTPBUTTON']){
                        $subGroupImages = $subGroup['DSENDEIMG'] != null ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM').$subGroup['DSENDEIMG'] : null;
                        $subGroupArray = [
                            "subGroupName"        => $subGroup['NMGRUPO'],
                            "subGroupImage"       => $subGroup['DSENDEIMG'],
                            "subGroupImages"      => !empty($subGroupImages) ? $this->util->buildCachedImages(basename($subGroupImages)) : null,
                            "subGroupCode"        => $subGroup['NRBUTTON'],
                            "subGroupDescription" => $subGroup['DSITMENUVENDA'],
                            "products"            => []
                        ];

                        foreach($products as $product){
                            if($product['NRBUTTONAUX'] == $subGroup['NRBUTTON'] && $product['IDTPBUTONAUX'] == $subGroup['IDTPBUTTON']){
                                $productImage = !empty($product['DSENDEIMG']) ? $this->util->getEnvironmentParam('URL_SERVIDOR_IMAGEM') . $product['DSENDEIMG'] : null;
                                $subGroupProduct = [
                                    "productBarCode"        => $product['CDBARPRODUTO'],
                                    "productCode"           => $product['CDPRODUTO'],
                                    "productName"           => $product['DSBUTTON'],
                                    "productDescription"    => $product['DESCRIPTION'],
                                    "productImage"          => $productImage,
                                    "productImages"         => $this->util->buildCachedImages(basename($productImage)),
                                    "productPrint"          => 'S',
                                    "productShowOnMenu"     => !empty($product['IDEXIBEAPPCONS']) ? $product['IDEXIBEAPPCONS'] : 'S',
                                    "productShowOrder"      => (!empty($product['NRPGCONFTELA']) && !empty($product['NRBUTTON'])) ? $product['NRPGCONFTELA'] . '|' . $product['NRBUTTON'] : '',
                                    "productAddProducts"    => [],
                                    "creditFamily"          => null,
                                    "productGroups"         => [],
                                    "observationsChoice"    => [],
                                    "fullPrice"             => 0,
                                    "price"                 => 0,
                                    "discount"              => 0,
                                    "addition"              => 0
                                ];

                                // Base price
                                $subGroupProduct['fullPrice'] = (!empty($productPrices['prices'][$subGroupProduct['productCode']]['PRECO']) ? $productPrices['prices'][$subGroupProduct['productCode']]['PRECO'] : 0.01);
                                $subGroupProduct['price'] = $subGroupProduct['fullPrice'];
                
                                //Daily price
                                if(!empty($productPrices['dailyPrices'][$subGroupProduct['productCode']])){
                                    if($productPrices['dailyPrices'][$subGroupProduct['productCode']]['IDDESCACREPR'] === 'D'){
                                        if($productPrices['dailyPrices'][$subGroupProduct['productCode']]['IDPERVALORPR'] === 'V'){
                                        $subGroupProduct['price'] -= $productPrices['dailyPrices'][$subGroupProduct['productCode']]['VRPRECODIA'];
                                        } else{
                                        $subGroupProduct['price'] -= ($subGroupProduct['price'] * ($productPrices['dailyPrices'][$subGroupProduct['productCode']]['VRPRECODIA'] / 100));
                                        }
                                    } else{
                                        if($productPrices['dailyPrices'][$product['productCode']]['IDPERVALORPR'] === 'V'){
                                        $subGroupProduct['price'] += $productPrices['dailyPrices'][$product['productCode']]['VRPRECODIA'];
                                        } else{
                                        $subGroupProduct['price'] += ($subGroupProduct['price'] * ($productPrices['dailyPrices'][$subGroupProduct['productCode']]['VRPRECODIA'] / 100));
                                        }
                                    }
                                }
                                
                                $subGroupProduct['price'] = floatval(bcadd((string)$subGroupProduct['price'], '0.00', 2));
                                $subGroupProduct['discount'] = floatval(bcsub((string)$subGroupProduct['fullPrice'], $subGroupProduct['price'], 2));
                                if($subGroupProduct['discount'] < 0.00){
                                    $subGroupProduct['addition'] = -1 * $subGroupProduct['discount'];
                                    $subGroupProduct['discount'] = 0.0;
                                } else{
                                    $subGroupProduct['addition'] = 0.0;
                                }
                                array_push($subGroupArray['products'], $subGroupProduct);
                            }
                        }
                    }
                }
                array_push($layout, $groupArray);
            }
            $data = [
                'groups' => $layout
            ];
            
			$return = [
				'error' => false,
				'data' 	=> $data
			];
		} catch (\Exception $e){
			$return = [
				'error'   => true,
			    'message' => "Erro ao buscar produtos fracionados. Erro: " . $e->getMessage()
			];
		}

		return $return;
	}
}